#pragma once
#include "ThreadJob.h"
#include "define.h"						// パケット作成のため

#define	CMD_BUFF_SIZE	(1024 * 64)		// ファイル送信コマンド格納リングバッファのサイズ

class CMySyncObject;					// CMySyncObjectを使うため
class CSendRecvThread;					// CSendRecvThreadを使うため
class CRingBuff;						// CRingBuffを使うため

class CChatMsgThread :
	public CThreadJob
{
public:
	CChatMsgThread(CSendRecvThread *pCSendRecvThread);
	~CChatMsgThread();

	CRingBuff	*m_pCRingBuffCmd;					// コマンド格納リングバッファ

	UINT DoWork() override;
	BOOL IsZombie();								// このスレッドはゾンビ状態か
	int GetDataForDistributeChat(char **ppcData);	// チャット分配用データの取得

private:
	CSendRecvThread	*m_pCSendRecvThread;
	CMySyncObject 	*m_pCMySyncObject;
	BOOL			m_fIamZombie;					// ゾンビ状態か
	CRingBuff		*m_pCRingBuffForDistributeChat;	// チャットメッセージをクライアントに配信するためのリングバッファ

	int AnalyzeCmd();
	int RecvMessagePacket(MsgDataRec *pbPacket);
	BOOL SendMessagePacket(char *pcData, int iSize);
	BOOL SetDataForDistributeChat(char *pcData, int iSize);	// チャットメッセージをクライアントに分配するために格納する

};

