#pragma once
#include "ThreadJob.h"
#include "define.h"						// パケット作成のため

#define	CMD_BUFF_SIZE	(1024 * 64)		// ファイル送信コマンド格納リングバッファのサイズ
// ファイル受信遷移状態
#define RECV_FILE_STAT_IDLE		0		// 初期状態
#define RECV_FILE_STAT_ING		1		// ファイル受信中
#define RECV_FILE_STAT_ABORT	2		// 中断処理中

class CMySyncObject;					// CMySyncObjectを使うため
class CSendRecvThread;					// CSendRecvThreadを使うため
class CRingBuff;						// CRingBuffを使うため

class CRecvFileThread :
	public CThreadJob
{
public:
	CRecvFileThread(CSendRecvThread *pCSendRecvThread);
	~CRecvFileThread();

	CRingBuff	*m_pCRingBuffCmd;		// ファイル送信コマンド格納リングバッファ

	UINT DoWork() override;
	BOOL IsZombie();					// このスレッドはゾンビ状態か

private:
	// ファイル名文字列(nullターミネートを含む)UTF-8 エラー時ファイル削除用
	char 			m_szFileName[FILE_NAME_LEN + 1];
	CSendRecvThread	*m_pCSendRecvThread;
	CMySyncObject 	*m_pCMySyncObject;
	BOOL			m_fIamZombie;		// ゾンビ状態か

	int				m_iRecvFileStatus;	// 遷移状態 RECV_FILE_STAT_IDLE/RECV_FILE_STAT_ING

	int				m_fdDstFile;		// 受信ファイルディスクリプタ

	int AnalyzeCmd();
	int RecvSendFileStartPacket(SendFileStartReqRec *pbPacket);	// ①指定されたファイルをオープンする
	int RecvSendFileIngPacket(SendFileIngRec *pbPacket);		// ②ファイルを書き込む
	int RecvSendFileEndPacket(SendFileEndReqRec *pbPacket);		// ③ファイルをクローズする
	int RecvSendFileAbortPacket(SendFileAbortReqRec *pbPacket);	// ファイルをクローズして削除
	BOOL SendSendFileStartResPacket(char cResCode);				// ファイル送信開始要求に対する応答を送信する
	BOOL SendSendFileEndResPacket(char cResCode);				// ファイル送信完了要求に対する応答を送信する
	BOOL SendSendFileAbortResPacket(char cResCode);				// ファイル送信中断要求に対する応答を送信する
};

